org.apache.tomcat.util.http.fileupload

## Class IOUtils

- java.lang.Object
- - org.apache.tomcat.util.http.fileupload.IOUtils

    public class IOUtils
    extends Object

General IO stream manipulation utilities.

This class provides static utility methods for input/output operations.

- closeQuietly - these methods close a stream ignoring nulls and exceptions
- toXxx/read - these methods read data from a stream
- write - these methods write data to a stream
- copy - these methods copy all the data from one stream to another
- contentEquals - these methods compare the content of two streams

The byte-to-char methods and char-to-byte methods involve a conversion step. Two methods are provided in each case, one that uses the platform default encoding and the other which allows you to specify an encoding. You are encouraged to always specify an encoding because relying on the platform default can lead to unexpected results, for example when moving from development to production.

All the methods in this class that read a stream are buffered internally. This means that there is no cause to use a `BufferedInputStream` or `BufferedReader`. The default buffer size of 4K has been shown to be efficient in tests.

Wherever possible, the methods in this class do not flush or close the stream. This is to avoid making non-portable assumptions about the streams' origin and further use. Thus the caller is still responsible for closing streams after use.

Origin of code: Excalibur.

### Constructor Summary

Constructors
Constructor and Description
`IOUtils()` Instances should NOT be constructed in standard programming.

### Method Summary

Methods
`static int` `copy(InputStream input, OutputStream output)` Copy bytes from an `InputStream` to an `OutputStream`.
`static long` `copyLarge(InputStream input, OutputStream output)` Copy bytes from a large (over 2GB) `InputStream` to an `OutputStream`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### IOUtils

    public IOUtils()

Instances should NOT be constructed in standard programming.

### Method Detail

#### copy

    public static int copy(InputStream input,
           OutputStream output)
                    throws IOException

Copy bytes from an `InputStream` to an `OutputStream`.

This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

Large streams (over 2GB) will return a bytes copied value of `-1` after the copy has completed since the correct number of bytes cannot be returned as an int. For large streams use the `copyLarge(InputStream, OutputStream)` method.

Parameters:
  `input` - the `InputStream` to read from
  `output` - the `OutputStream` to write to
Returns:
  the number of bytes copied, or -1 if > Integer.MAX_VALUE
Throws:
  `NullPointerException` - if the input or output is null
  `IOException` - if an I/O error occurs
Since:
  1.1

#### copyLarge

    public static long copyLarge(InputStream input,
                 OutputStream output)
                          throws IOException

Copy bytes from a large (over 2GB) `InputStream` to an `OutputStream`.

This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

The buffer size is given by `DEFAULT_BUFFER_SIZE`.

Parameters:
  `input` - the `InputStream` to read from
  `output` - the `OutputStream` to write to
Returns:
  the number of bytes copied
Throws:
  `NullPointerException` - if the input or output is null
  `IOException` - if an I/O error occurs
Since:
  1.3